#include <windows.h>
#include <stdio.h>

int shell_ok(const char *lpfilename)
{
    PROCESS_INFORMATION pinfo = { 0 };
    STARTUPINFO sinfo = { 0 };
    BOOL bRet;
    int xc = -1;

    /* create process */
    bRet = CreateProcess(NULL, (char *)lpfilename, NULL, NULL,
                         FALSE, 0, NULL, NULL, &sinfo, &pinfo);

    if (!bRet) return -1;


    /* wait for process to terminate */
    WaitForSingleObject(pinfo.hProcess, INFINITE);

    /* get exit code of process */
    GetExitCodeProcess(pinfo.hProcess, &xc);

    /* close open handles */
    CloseHandle(pinfo.hProcess);
    CloseHandle(pinfo.hThread);

    /* return exit code */
    return xc;
}

int shell_hutch(const char *lpfilename)
{
    PROCESS_INFORMATION pinfo = { 0 };
    STARTUPINFO sinfo = { 0 };
    BOOL bRet;
    int xc = -1;

    /* create process */
    bRet = CreateProcess(NULL, (char *)lpfilename, NULL, NULL,
                         FALSE, 0, NULL, NULL, &sinfo, &pinfo);

    if (!bRet) return -1;

    /* wait for process to terminate using hutch-- method */
    while (GetExitCodeProcess(pinfo.hProcess, &xc) &&
           (xc == STILL_ACTIVE)) Sleep(0);

    /* close open handles */
    CloseHandle(pinfo.hProcess);
    CloseHandle(pinfo.hThread);

    /* return exit code */
    return xc;
}

int main()
{
    DWORD start, end;
    unsigned int i;


    printf("- 1000 runs of 'client.exe' using shell_ok ... ");

    start = GetTickCount();

    for (i = 0; i < 1000; ++i) shell_ok("client.exe");

    end = GetTickCount();

    printf("%u ms\n", end - start);


    printf("- 1000 runs of 'client.exe' using shell_hutch ... ");

    start = GetTickCount();

    for (i = 0; i < 1000; ++i) shell_hutch("client.exe");

    end = GetTickCount();

    printf("%u ms\n", end - start);


    return 0;
}
